#include <stdio.h>

#define MAXW 5000

/*
Rihannsu
 ____  _ _                                 
|  _ \(_) |__   __ _ _ __  _ __  ___ _   _ 
| |_) | | '_ \ / _` | '_ \| '_ \/ __| | | |
|  _ <| | | | | (_| | | | | | | \__ \ |_| |
|_| \_\_|_| |_|\__,_|_| |_|_| |_|___/\__,_|
                                           
                                         
*/

#define PROG "Rihannsu: Rihannsu Language Tool"
#define VERS "1"
#define LVL "0"
#define DATE "September 8, 2000"
#define DFLT_DICT "rih.voc"

int silent=0;
char FILENM[2000];
char *vdict[2][MAXW];
char dict[MAXW][512];
int wcount=0;
/*
     _                                                   _       _ 
  __| | ___   ___ ___  _ __ ___  _ __ ___   ___ _ __ ___(_) __ _| |
 / _` |/ _ \ / __/ _ \| '_ ` _ \| '_ ` _ \ / _ \ '__/ __| |/ _` | |
| (_| | (_) | (_| (_) | | | | | | | | | | |  __/ | | (__| | (_| | |
 \__,_|\___/ \___\___/|_| |_| |_|_| |_| |_|\___|_|  \___|_|\__,_|_|
*/
docommercial(){
  if (silent == 0){
 	printf ("\n\nRihannsu Language Tool %s.%s\nJoel Peter Anderson, %s\n",VERS,LVL,DATE);
	printf ("Visit the UTA Project at \n\thttp://members.aol.com/jpklingon/uta\n\n");
printf (" ____  _ _                                 \n");
printf ("|  _ \\(_) |__   __ _ _ __  _ __  ___ _   _ \n");
printf ("| |_) | | '_ \\ / _` | '_ \\| '_ \\/ __| | | |\n");
printf ("|  _ <| | | | | (_| | | | | | | \\__ \\ |_| |\n");
printf ("|_| \\_\\_|_| |_|\\__,_|_| |_|_| |_|___/\\__,_|\n");
printf ("                                           \n");
  }
}

/*
                   _ _ _       
  ___ _ __ ___  __| (_) |_ ___ 
 / __| '__/ _ \/ _` | | __/ __|
| (__| | |  __/ (_| | | |_\__ \
 \___|_|  \___|\__,_|_|\__|___/
                               
*/
credits () {
char bogus[90];
fflush (stdin);
printf (" Note on Sources: The source for each word is indicated in\n");
printf (" parenthesis after the word, as follows:\n");
printf ("(EA #) - My Enemy, My Ally, found on indicated page\n");
printf ("(RW #) - The Romulan Way, found on indicated page\n");
printf ("(G) - Glossary of The Romulan Way\n");
printf ("(S) - Star Trek episode or movie\n");
printf ("(F) - FASA\n");
printf ("(P) - the Rihannsu Language Project\n");
printf ("(D) - Copyright  1997 John A. Dutka, Jr.\n");
printf ("(I) - other\n");
printf (" \n");
printf ("Star Trek, Star Trek: The Next Generation, Star Trek: Deep Space Nine\n");
printf ("and Star Trek: Voyager are registered trademarks of Paramount Pictures\n");
printf ("Corporation. The novels My Enemy, My Ally by Diane Duane and The\n");
printf ("Romulan Way by Diane Duane and Peter Morwood are copyrighted by\n");
printf ("Paramount Pictures. No infringement upon these or any other copyrights\n");
printf ("or trademarks is intended.\n");
printf ("Press ENTER\n");
gets(bogus);
}

/*
 _   _ ___  __ _  __ _  ___ 
| | | / __|/ _` |/ _` |/ _ \
| |_| \__ \ (_| | (_| |  __/
 \__,_|___/\__,_|\__, |\___|
                 |___/      

*/

void usage(){
  printf ("rihannsu - Rihannsu Language Tool\n");
  printf (" usage:  rihannsu  - enter interactive use\n");
  printf (" \t  rihannsu  -d  show complete dictionary\n");
  printf (" \t  rihannsu  -r [list] look up Rihannsu words\n");
  printf (" \t  rihannsu  -e [list] look up English words \n\n");
}

/*
               _ _              _ _      _   
__      ___ __(_) |_ ___     __| (_) ___| |_ 
\ \ /\ / / '__| | __/ _ \   / _` | |/ __| __|
 \ V  V /| |  | | ||  __/  | (_| | | (__| |_ 
  \_/\_/ |_|  |_|\__\___|___\__,_|_|\___|\__|
                       |_____|               

*/
int write_dict(char *filename){
	FILE *WT;
	int x;

	strcpy (FILENM,FILEHOME);
	strcat (FILENM,filename);

	if (WT = fopen(FILENM,"w")){

	for (x=0;x<wcount;x++){
	  fprintf (WT,"\"%s\",\"%s\"\n",vdict[0][x],vdict[1][x]);
	}
	fclose (WT);
	return (x);
   }
	return (0);
}

void display_dict(int index){
  int x,y;
  char *ptr;
  /*display*/
  printf ("*****\n%s\n",vdict[0][index]);
  printf ("\t");
  ptr=vdict[1][index];
  y=0;
  
  for(x=0;x<strlen(vdict[1][index]);x++){
    printf ("%c",*ptr);
    if ((*ptr==' ')&&(y>=63)){
      printf("\n\t");
      y=0;
    }
    y++;
    ptr++;
  }
  printf ("\n-----\n");
}

void noquote(char *word){

	while (*word != '\0'){
		if (*word == '"') {
			*word = '\'';
		}
		word++;
	}	
}

void add_word(){
	char VULC[100];
	char KEY[100];
	char ENG[1000];
	printf ("Rihannsu word? ");
    scanf("%s",VULC);
	printf ("English keyword? ");
    scanf("%s",KEY);
	fflush (stdin);
	printf ("English definition? ");
    gets(ENG);
    vdict[0][wcount]=dict[wcount];
    strcpy(vdict[0][wcount],VULC);
    vdict[1][wcount]=vdict[0][wcount]+(strlen(VULC)+1);
    sprintf (vdict[1][wcount],"%s: %s",KEY,ENG); 
	printf ("Added - \n");
	noquote (vdict[0][wcount]);
	noquote (vdict[1][wcount]);
	display_dict(wcount);
	wcount++;
	printf("[wrote out newrih.voc dictionary of %d words]\n",write_dict("newrih.voc"));
}

int contain(char *targ, char *super){
  
  int x;
  char *ugh;

  ugh = super;
    if (strcasecmp(targ,ugh)==0) return 1;
 for (x=0;x<strlen(super);x++){
     if (strncasecmp(targ,ugh,strlen(targ))==0) return 1;
     ugh++;

  }
  return 0;
}


int read_dict(){
  
  FILE *vfile;
  char *ptr;
  char entry[2000];

	strcpy (FILENM,FILEHOME);
	strcat (FILENM,DFLT_DICT);

  vfile=fopen(FILENM,"r");
  if (vfile){
  for (wcount=0;wcount<MAXW;wcount++)
    {
      /*retrieve the dictionary entry*/
      if  (!fgets(entry,sizeof(entry),vfile)) break;
      
      /*copy it into the array*/
      /*		vdict[0][wcount]=(char*)malloc(strlen(entry));*/
      vdict[0][wcount]=dict[wcount];
      
      strcpy(vdict[0][wcount],entry);
      
      /*adjust to first non "*/
      while (*vdict[0][wcount]=='"') vdict[0][wcount]++;
      ptr=vdict[0][wcount];
      while (*ptr!='"') ptr++;
      *ptr=(char)0;
      
      /*find definition*/
      while (*ptr!='"') ptr++;
      ptr++;
      vdict[1][wcount]=ptr;
      while (*ptr!='"') ptr++;
      *ptr=(char)0;
    }/*end for*/
  }else{
    printf ("error.  Couldn't open %s\n",FILENM);
  }
  return wcount;
}
void show_dict()
{
  int index,x,y;
  char *ptr;

  
  for(index=0;index<wcount;index++){
    /*display*/
    printf ("*****\n%s\n",vdict[0][index]);
    printf ("\t");
    ptr=vdict[1][index];
    y=0;
    
    for(x=0;x<strlen(vdict[1][index]);x++){
      printf ("%c",*ptr);
      if ((*ptr==' ')&&(y>=63)){
	printf("\n\t");
	y=0;
      }
      y++;
      ptr++;
    }
    printf ("\n-----\n");
  }

}
fengl(char *input){
  int x;
  for (x=0;x<wcount;x++){
    if (contain(input,vdict[1][x])) display_dict(x);
  }
}

engl(){
  char input[255];
  printf("English search string? (q to quit) ");
  scanf("%s",input);
  while (strcasecmp(input,"q")){
    fengl(input);
    printf("English search string? (q to quit) ");
    scanf("%s",input);
  }
}

fvulc (char *input){
  int x;
  for (x=0;x<wcount;x++){
    if (contain(input,vdict[0][x])) display_dict(x);
  }
}
vulc(){
  char input[255];
  printf("Rihannsu search string? (q to quit) ");
  scanf("%s",input);
  
  while (strcasecmp(input,"q")){
    fvulc(input);
    printf("Rihannsu search string? (q to quit) ");
    scanf("%s",input);
  }
}


do_menu(){
  char input[80];
  

  while (1) {

    printf("\n\tRihannsu Language Tool\n");
    printf("\n\n\n\n\n\tR. Lookup Rihannsu text\n"); 
    printf("\n\tE. Lookup English text\n"); 
    printf("\n\tD. Display Dictionary text\n"); 
    printf("\n\tA. Add Dictionary entry\n"); 
    printf("\n\tC. Credits\n"); 
    printf("\n\tQ. quit\n");
    
    scanf("%s", input);
    switch(*input){
      
    case 'q':
    case 'Q':
      return;

    case 'c':
    case 'C':
	  credits();
		break;
      
    case 'e': 
    case 'E': 
      engl();
      break;
      
    case 'R': 
    case 'r': 
      vulc();
      break;
	  
    case 'a': 
    case 'A': 
      add_word();
      break;

      
    case 'd': 
    case 'D': 
      show_dict();
      break;
      
    }
  }
}



main(int argc, char *argv[])
{
  int x;
  /*initialize dictionary*/
  
  printf("%d Word entries\n",read_dict());
  if(argc == 1) {
    printf("\n\tRihannsu Dictionary \n\tbased on Diane Duane's Rihanssu language\n\twith additions from the fan community.\n\n");
    do_menu();
  }else{
    if (strcasecmp (argv[1],"-r")==0){
      printf("Rihannsu Word Lookup\n\n ");
      for (x=2;x<argc;x++) fvulc(argv[x]);
    }else{  
      if (strcasecmp (argv[1],"-d")==0){
	printf("Display Rihannsu Dictionary\n\n ");
	show_dict();
      } else { 
	if (strcasecmp (argv[1],"-e")==0){
	  printf("English Word Lookup\n\n ");
	  for (x=2;x<argc;x++) fengl(argv[x]);
	}else{
	  usage();
      }
    }
 
    printf("\n\tRihannsu Dictionary \n\tbased on Diane Duane's Rihanssu language\n\twith additions from the fan community.\n\n");
  }
  
}  
  
	docommercial();
  
}
